javax.faces.bean

## Annotation Type ManagedBean

-     @Retention(value=RUNTIME)
      @Target(value=TYPE)
      @Inherited
      public @interface ManagedBean

  The presence of this annotation on a class automatically registers the class with the runtime as a managed bean class. Classes must be scanned for the presence of this annotation at application startup, before any requests have been serviced.

  The value of the `name()` attribute is taken to be the managed-bean-name. If the value of the name attribute is unspecified or is the empty `String`, the managed-bean-name is derived from taking the unqualified class name portion of the fully qualified class name and converting the first character to lower case. For example, if the `ManagedBean` annotation is on a class with the fully qualified class name `com.foo.Bean`, and there is no name attribute on the annotation, the managed-bean-name is taken to be `bean`. The fully qualified class name of the class to which this annotation is attached is taken to be the managed-bean-class.

  The scope of the managed bean is declared using one of `NoneScoped`, `RequestScoped`, `ViewScoped`, `SessionScoped`, `ApplicationScoped`, or `CustomScoped` annotations. If the scope annotations are omitted, the bean must be handled as if the `RequestScoped` annotation is present.

  If the value of the `eager()` attribute is `true`, and the `managed-bean-scope` value is "application", the runtime must instantiate this class when the application starts. This instantiation and storing of the instance must happen before any requests are serviced. If eager is unspecified or `false`, or the `managed-bean-scope` is something other than "application", the default "lazy" instantiation and scoped storage of the managed bean happens.

  When the runtime processes this annotation, if a managed bean exists whose name is equal to the derived managed-bean-name, a `FacesException` must be thrown and the application must not be placed in service.

  A class tagged with this annotation must have a public zero-argument constructor. If such a constructor is not defined on the class, a `FacesException` must be thrown and the application must not be placed in service.

  Since:
    2.0

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `boolean` | `eager` Taken to be the value of the `eager` attribute of the `managed-bean`.
    `String` | `name` Taken to be the `managed-bean-name`.

- - ### Element Detail

    - #### name

          public abstract String name

      Taken to be the `managed-bean-name`. See class documentation for details.

      Default:
        ""

    - #### eager

          public abstract boolean eager

      Taken to be the value of the `eager` attribute of the `managed-bean`. See class documentation for details.

      Default:
        false

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.